models/Formulario.php
<?php
namespace app\models;
use yii\base\Model;

class Formulario extends Model {
// todos los campos del formulario
    public ?string $nombre=null;
    public  ?string $apellidos=null;
    public ?string $fechaNacimiento=null;
    public ?string $correo=null;
    public ?string $poblacion=null;
    public array $meses=[];

    public function attributeLabels():array{
        return [];
    }

    public function rules():array{
        return [
           [['nombre','apellidos','fechaNacimiento','correo','poblacion','meses'],'required'],
           [['fechaNacimiento'],'date','format'=>'yyyy-MM-dd','max'=>'2023-12-31'], 
        ];
    }

    /**
     * Son las poblaciones a mostrar en el desplegable
     */
    public function getPoblaciones(){
        return [
            "Laredo"=>"Laredo",
            "Santander"=>"Santander",
            "Astillero"=>"Astillero"
        ];
    }
    /**
     * Son los meses a mostrar en el control de checkboxlist
     */
    public function getListadoMeses() {
        return [
                "junio"=>"junio",
                "julio"=>"julio",
                "agosto"=>"agosto",
                "septiembre"=>"septiembre"
            ];
    }

    public function getMesesSeleccionados(){
        return join(",",$this->meses);
    }

}

controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Formulario;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionFormulario(){
        $model = new Formulario();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render("solucion",[
                    "model" => $model
                ]);
            }
        }
    
        return $this->render('formulario', [
            'model' => $model,
        ]);
    }

   
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header id="header">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Formulario', 'url' => ['/site/formulario']],
          
        ]
    ]);
    NavBar::end();
    ?>
</header>

<main id="main" class="flex-shrink-0" role="main">
    <div class="container">
        <?php if (!empty($this->params['breadcrumbs'])): ?>
            <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
        <?php endif ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer id="footer" class="mt-auto py-3 bg-light">
    <div class="container">
        <div class="row text-muted">
            <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
            <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
        </div>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/formulario.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario">

    <?php $form = ActiveForm::begin(); ?>

        <?= 
            $form
                ->field($model, 'nombre') 
                ->textInput([
                    "placeholder" => "introduce nombre completo"
                ])
        ?>
        <?= 
            $form
                ->field($model, 'apellidos') 
                ->textInput([
                    "placeholder" => "Introduce dos apellidos"
                ])
        ?>
        <?= 
            $form
                ->field($model, 'fechaNacimiento') 
                ->input("date")
        ?>
        <?= 
            $form
                ->field($model, 'correo') 
                ->input("email")
        ?>
        <?= 
            $form
                ->field($model, 'poblacion') 
                ->dropDownList(
                    $model->poblaciones
                )
        ?>

        <?= 
            $form   
                    ->field($model,'meses')
                    ->checkboxList(
                        $model->listadoMeses
                    )
        ?>                       
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario -->

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Formularios 4';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Formularios 4</h1>

        <p class="lead">Ejemplo de formularios con seleccion multiple</p>
        
    </div>

</div>

views/site/solucion.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    "model" => $model,
    "attributes"=>[
        "nombre",
        "apellidos",
        "fechaNacimiento",
        "correo",
        "poblacion",
        "mesesSeleccionados"
    ]

    
]);